;;; fuelle-Endversion.scm
; fertig

;;; ----- fuelle -----
(define (fuelle stuecke container)
  (cond
    ((exakt-voll? container)   ; erst Erfolgsfall pruefen
     container)
    ((null? stuecke)           ; Misserfolgsfall
     #f)
    ((zu-voll? (first stuecke) container)
     (fuelle (rest stuecke) container))
    (else
     (fuelle
      (rest stuecke)
      (fuelle-ein (first stuecke) container)))
    ))

; ----- exakt-voll? -----
; prueft, ob der Container vollstaendig gefuellt ist
; (Praedikat container -> boolean)
(define
  (exakt-voll? container)
  (= (first container) (fuellung container))
  )

;;; dafuer notwendige Hilfsfunktionen:
; ----- fuellung -----
; bestimmt den aktuellen Fuellzustand des Containers
; container -> integer
(define
  (fuellung container)
  ;;; einfache Loesung mit apply
  (apply + (rest container)))
;;; Alternativ Hilfsfunktion summe einsetzen

; ----- zu-voll? -----
; prueft, ob der Container mit dem stueck ueberfuellt ist
; (Praedikat container -> boolean)
(define
  (zu-voll? stueck container)
  (< (first container) (+ stueck (fuellung container))))

;;; ----- fuelle-ein -----
; fuellt ein Stueck in den Container ein
(define
  (fuelle-ein stueck container)
  (cons
   (first container)            ; wieder zusammenbauen
   (cons stueck (rest container)))   ; zu den Stuecken
  )

;;;---------------------------------------------
; Container sind Listen mit der Groesse am Kopf
(define (erzeuge-container groesse)
  (list groesse))

;;; ----- globale Variable fuer Testzwecke -----
(define
  *container*
  (erzeuge-container 80))
; ----- Alternative -----
;  (erzeuge-container 100))

(define
  *stuecke*
  (list 30 30 30 30 20 20 20 20))

;;; ----- Test -----
(fuelle *stuecke* *container*)
(fuelle '() *container*)
(fuelle '(20 20) '(80 30 30 20))
(fuelle '(30 20) '(80 30 30))
