; fuelle_Erarbeitung.scm

; Modul fuer komfortable Ausgabe laden
(load "../breakpoint.scm")       ; ggf Pfad anpassen

; Container sind Listen mit der Groesse am Kopf
(define (erzeuge-container groesse)
  (list groesse))

;;; ----- globale Variable fuer Testzwecke -----
;;; ein Container
(define
  *container*
  (erzeuge-container 80))

;;; Stuecke: einfache Liste von Zahlen
(define
  *stuecke*
  '(30 30 30 30 20 20 20 20))

;;;---------------------------------------------
;;; Version 0: Kopf mit "leerem" Rumpf
;;; ----- fuelle -----
(define (fuelle stuecke container)
  'undefiniert
  )
;;; ----- Tests -----
(ausgabe "Tests zu Version 0")
(fuelle *stuecke* *container*)
(fuelle '() *container*)

;;;---------------------------------------------
;;; Version 1: Verzweigung einbauen

;;; ----- fuelle -----
(define (fuelle stuecke container)
  (cond
    ((null? stuecke)           ; Misserfolgsfall
     #f)
    (else
     'undefiniert)
    ))

;;; ----- Tests -----
(ausgabe "Tests zu Version 1")
(fuelle *stuecke* *container*)
(fuelle '() *container*)

;;;---------------------------------------------
;;; Version 2: erst den Erfolgsfall testen

;;; ----- fuelle -----
(define (fuelle stuecke container)
  (cond
    ((exakt-voll? container)   ; erst Erfolgsfall pruefen
     container)
    ((null? stuecke)           ; Misserfolgsfall
     #f)
    (else
     'undefiniert)
    ))

; ----- Hilfsfunktion ab Version 2 -----
; ----- exakt-voll? -----
; prueft, ob der Container vollstaendig gefuellt ist
; (Praedikat container -> boolean)
(define
  (exakt-voll? container)
  ; muss entwickelt werden!
  #f)

;;; ----- Tests -----
(ausgabe "Tests zu Version 2")
(fuelle *stuecke* *container*)
(fuelle '() *container*)
(fuelle '(20 20) '(80 30 30 20))

;;;---------------------------------------------
;;; exakt-voll? realisiert:
; ----- exakt-voll? -----
; prueft, ob der Container vollstaendig gefuellt ist
; (Praedikat container -> boolean)
(define
  (exakt-voll? container)
  (= (first container) (fuellung container))
  )

;;; dafuer notwendige Hilfsfunktionen:
; ----- fuellung -----
; bestimmt den aktuellen Fuellzustand des Containers
; container -> integer
(define
  (fuellung container)
  ;;; einfache Loesung mit apply
  (apply + (rest container)))
;;; Alternativ Hilfsfunktion summe einsetzen

;;; Version 3: mit dem Stueck wird der Container zu voll
; ==> mit dem naechsten Stueck versuchen

;;; ----- fuelle -----
(define (fuelle stuecke container)
  (cond
    ((exakt-voll? container)   ; erst Erfolgsfall pruefen
     container)
    ((null? stuecke)           ; Misserfolgsfall
     #f)
    ((zu-voll? (first stuecke) container)
     (fuelle (rest stuecke) container))
    (else
     'undefiniert)
    ))

; ----- zu-voll? -----
; prueft, ob der Container mit dem stueck ueberfuellt ist
; (Praedikat container -> boolean)
(define
  (zu-voll? stueck container)
  ; muss entwickelt werden!
  #f)

;;; ----- Tests -----
(ausgabe "Tests zu Version 3")
(fuelle *stuecke* *container*)
(fuelle '() *container*)
(fuelle '(20 20) '(80 30 30 20))
(fuelle '(30 20) '(80 30 30))

;;;---------------------------------------------
;;; zu-voll? realisiert:
; ----- zu-voll? -----
; prueft, ob der Container mit dem stueck ueberfuellt ist
; (Praedikat container -> boolean)
(define
  (zu-voll? stueck container)
  (< (first container) (+ stueck (fuellung container))))

;;; Version 4: else-Fall: das Stueck kann eingefuellt werden

;;; ----- fuelle -----
(define (fuelle stuecke container)
  (cond
    ((exakt-voll? container)   ; erst Erfolgsfall pruefen
     container)
    ((null? stuecke)           ; Misserfolgsfall
     #f)
    ((zu-voll? (first stuecke) container)
     (fuelle (rest stuecke) container))
    (else
     (fuelle
      (rest stuecke)
      (fuelle-ein (first stuecke) container)))
    ))

; ----- Hilfsfunktion ab Version 4 -----
;;; ----- fuelle-ein -----
; fuellt ein Stueck in den Container ein
(define
  (fuelle-ein stueck container)
  container)   ; macht noch nichts

;;; ----- Tests -----
(ausgabe "Tests zu Version 4")
(fuelle *stuecke* *container*)
(fuelle '() *container*)
(fuelle '(20 20) '(80 30 30 20))
(fuelle '(30 20) '(80 30 30))

;;;---------------------------------------------
;;; fuelle-ein realisiert:

;;; ----- fuelle-ein -----
; fuellt ein Stueck in den Container ein
(define
  (fuelle-ein stueck container)
  (cons
   (first container)            ; wieder zusammenbauen
   (cons stueck (rest container)))   ; zu den Stuecken
  )

;;; ----- Tests -----
(ausgabe "Tests zur Endversion")
(fuelle *stuecke* *container*)
(fuelle '() *container*)
(fuelle '(20 20) '(80 30 30 20))
(fuelle '(30 20) '(80 30 30))

